import sys
sys.path.append('../')

from model_checking import dfa
from model_checking import pctl

n_automaton_states = 12

automaton = dfa.DFA([s for s in range(n_automaton_states)], 0, [11])
automaton.add_edge(0, 1, dfa.And(dfa.Atom('goal'), dfa.Neg(dfa.Atom('blue'))))
automaton.add_edge(1, 0, dfa.Atom('blue'))
automaton.add_edge(1, 2, dfa.Neg(dfa.Atom('blue')))

automaton.add_edge(2, 0, dfa.Atom('blue'))
automaton.add_edge(2, 3, dfa.Neg(dfa.Atom('blue')))

automaton.add_edge(3, 0, dfa.Atom('blue'))
automaton.add_edge(3, 4, dfa.Neg(dfa.Atom('blue')))

automaton.add_edge(4, 0, dfa.Atom('blue'))
automaton.add_edge(4, 5, dfa.Neg(dfa.Atom('blue')))

automaton.add_edge(5, 0, dfa.Atom('blue'))
automaton.add_edge(5, 6, dfa.Neg(dfa.Atom('blue')))

automaton.add_edge(6, 0, dfa.Atom('blue'))
automaton.add_edge(6, 7, dfa.Neg(dfa.Atom('blue')))

automaton.add_edge(7, 0, dfa.Atom('blue'))
automaton.add_edge(7, 8, dfa.Neg(dfa.Atom('blue')))

automaton.add_edge(8, 0, dfa.Atom('blue'))
automaton.add_edge(8, 9, dfa.Neg(dfa.Atom('blue')))

automaton.add_edge(9, 0, dfa.Atom('blue'))
automaton.add_edge(9, 10, dfa.Neg(dfa.Atom('blue')))

automaton.add_edge(10, 0, dfa.Atom('blue'))
automaton.add_edge(10, 11, dfa.Neg(dfa.Atom('blue')))

automaton.add_edge(11, 0, dfa.Truth())

cost_function = dfa.Cost_Function(automaton)

def pctl_property(prob=0.9):
    return pctl.Implies(pctl.Atom('goal'), pctl.Eventually(prob, 10, pctl.Atom('blue')))

def product_pctl_property(prob=0.9):
    return pctl.Always(prob, 10, pctl.Neg(pctl.Atom('accepting')))